<?php

require_once('/usr/fallback/beroConf.php');

class apiCall {

	private $_name, $_get, $_post, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'ProvisioningGetConfiguration';
		$this->_get = $get;
		$this->_post = $post;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		$bc = new beroConf('root');

		if (!in_array(($protocol = $bc->get('root', 'provisioning-option')), array('http', 'tftp'))) {
			$this->_execResultString .= ':not_configured';
			return($this->_execResult);
		}

		$this->_execResultString .= ':Mode:' . (($bc->get('root', 'use-boot-prov') == 'yes') ? 'always' : 'off') .
						';Url:' . $bc->get('root', 'provisioning-option') . '://' .
						$bc->get('root', $protocol . '-host') . $bc->get('root', $protocol . '-url');

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . $this->_execResultString);
	}
}

?>
