<?php
include('/usr/fallback/beroConf.php');
include('/usr/local/php/include/fulltrace.Class.php');

/**
 * Klasse Fulltrace
 */

class fulltrace_gui {
	/*
	 * Die Funktion ports wird benutzt um alle ISDN Ports anzuzeigen.
	 */
	function ports() {
		//Ein neues Datenbankobjekt wird erzeugt.
		$ba = new beroAri();
		$qu = $ba->select("select * from isdn");
		//Alle Einträge von der Abfrage werden durchgelaufen
		while ($entry = $ba->fetch_array($qu)) {
			//Für jede Port wird ein checkbox erzeugt
			$select .= "<input type=checkbox name='ports[]' value='" . $entry['port'] . "' checked>" . $entry['port'] . "&nbsp;
			&nbsp;";

		}
		//Alle checkboxs werden zurückgegeben*/
		return $select;
	}

	/*
	 * Funktion display erzeugt den Inhalt von der HTML-Seite
	 */
	function display($args) {

		$ba = new beroAri();

		include('./includes/header.php');
		require_once ('./includes/isgwtelnet.php');
		$ret.= "<script language='javascript'>function checkallp(){
			var checkall = document.getElementById('checkall');
		var del = document.getElementsByName('ports[]');
		if (checkall.checked==true){
			for (i=0; i < del.length; i++){
				del[i].checked=true;
			}
		}else{
			for (i=0; i < del.length; i++){
				del[i].checked=false;
			}
		}

	}
	function dis(){
		var isdn_enable = document.getElementById('isdn_enable');
		var checkall = document.getElementById('checkall');
		var del = document.getElementsByName('ports[]');
		if (isdn_enable.checked==true){
			checkall.disabled=false;
			for (i=0; i < del.length; i++){
				del[i].disabled=false;
			}
		}else{
			checkall.disabled=true;
			for (i=0; i < del.length; i++){
				del[i].disabled=true;
			}
		}
	}
	</script>";
	$colspan=2;
	$th="";
	$td="";
	$query_gsm=$ba->select("select * from gsm");
	if(sqlite_num_rows($query_gsm)>0){
		$colspan++;
		$th.="<td>GSM</td>";
		$td.="<td><input type='checkbox' value='1' name='gsm' id='gsm' checked><label for='gsm'>".FULL_TRACE_ENABLE_DIS."</label></td>";
		$colspan++;
		$th.="<td>GSM SMS</td>";
		$td.="<td><input type='checkbox' value='1' name='gsm_sms' id='gsm_sms'><label for='gsm_sms'>".FULL_TRACE_ENABLE_DIS."</label></td>";
	}
	$query_analog=$ba->select("select * from analog");
	if(sqlite_num_rows($query_analog)>0){
		$colspan++;
		$th.="<td>ANALOG</td>";
		$td.="<td><input type='checkbox' value='1' name='analog' id='analog'  checked><label for='analog'>".FULL_TRACE_ENABLE_DIS."</label></td>";
	}
	$query_cas = $ba->select("select * from cas where port_type='cas'");
	if (sqlite_num_rows($query_cas) > 0) {
		$colspan++;
		$th.="<td>CAS</td>";
		$td.="<td><input type='checkbox' value='1' name='cas' id='cas'  checked><label for='analog'>" . FULL_TRACE_ENABLE_DIS . "</label></td>";
	}

	$fulltrace = new fulltrace();

	//Die Tabelle MISDN Trace
	if (($ba->get("trace")=="" || $ba->get("trace")=="no") && !isset($_POST['trace'])) {
		$ret .= "<br/><form class='extensions_form' method='POST'>
			<table class='contenttoc' id='table' style='width:473px;'>
			<tr><th colspan='$colspan'>".FULL_TRACE_TABLE_HEADER_DIS."</th></tr>
			<tr>
			<td>".FULL_TRACE_ISDN_PORTS_DIS."</td><td>".FULL_TRACE_SIP_DIS."</td>$th
			</tr>
			<tr>
			<td nowrap>
			<input type='checkbox' name='isdn_enable' id='isdn_enable' value='1' onclick='dis();' checked/>".FULL_TRACE_ENABLE_DIS."
			<br/>
			<b>".FULL_TRACE_CHECK_ALL_DIS."</b>
			<input type='checkbox' id='checkall' name='checkall' onclick='checkallp();' onmouseover=\"Tip('".DEBUG_CHECK_ALL."')\" onmouseout='UnTip()'>
			<br/>" . $this->ports() .
			"<br/>
			<br/>
			</td>
			<td>
			<input type='checkbox' name='sip_sign' id='sip_sign' value='1' onclick='if (sip_sign.checked==true) sip_audio.disabled=false; else sip_audio.disabled=true;' checked/>Sip Sign
			<br/>
			<input type='checkbox' name='sip_audio' id='sip_audio' value='1' /><label for='sip_audio'>Sip Audio</label>
			</td>
			$td
			</tr>
			<tr>
			<td colspan='$colspan'>
			<img src='./includes/images/punkt_rot.gif'>&nbsp;&nbsp;&nbsp;
			<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_START_TRACE."')\" onmouseout='UnTip()' value='".FULL_TRACE_BUTTON_START_DIS."'>
			</td>
			</tr>
			</table></form><br/>";
		/* Wenn man auf den Knopf Start geclickt hat, wird die module mISDN_debugtool.ko geladen
		   und das mISDNdebugtool mit den ausgewählten Ports ausgeführt */
	}elseif ($_POST['trace'] == 'Start' ) {

		$enable['isdn'] =	(($_POST['isdn_enable'] == '1') ? 1 : 0);
		$enable['analog'] =	(($_POST['analog'] == '1') ? 1 : 0);
		$enable['gsm'] =	(($_POST['gsm'] == '1') ? 1 : 0);
		$enable['cas'] =	(($_POST['cas'] == '1') ? 1 : 0);
		$enable['sip_sign'] =	(($_POST['sip_sign'] == '1') ? 1 : 0);
		$enable['sip_audio'] =	(($_POST['sip_audio'] == '1') ? 1 : 0);

		$bc = new beroConf('root');
		$log_size = (($bc->get('root', 'cifs_log_enabled') == '1') ? $bc->get('root', 'cifs_log_size') : null);

		$fulltrace->start($enable, $_POST['ports'], $log_size);
		unset($enable);

		if ((($_POST['ports'] != '') && ($_POST['isdn_enable'] == '1')) || ($_POST['sip_sign']=='1')) {
			$ret .= "<br/><form class='extensions_form' method='POST'>" .
				"<table class='contenttoc' style='width:473px;'><tr><th colspan='2'>".FULL_TRACE_TABLE_HEADER_DIS."</th></tr><tr>" .
				"<td><img src='./includes/images/punkt_gruen.gif'></td>
				<td>
				<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_STOP_TRACE."')\" onmouseout='UnTip()' value='Stop Full Trace'>
				</td></tr></table></form><br/>";
			//Wenn kein Port ausgewählt wurde, wird die Anfangstabelle angezeigt.
		} else {
			$ret .= "<br/><form class='extensions_form' method='POST'>
			<table class='contenttoc' style='width:473px;'>
			<tr><th colspan='$colspan'>".FULL_TRACE_TABLE_HEADER_DIS."</th></tr>
			<tr>
			<td>".FULL_TRACE_ISDN_PORTS_DIS."</td><td>".FULL_TRACE_SIP_DIS."</td>$th
			</tr>
			<tr>
			<td nowrap>
			<input type='checkbox' name='isdn_enable' id='isdn_enable' value='1' onclick='dis();' checked/>".FULL_TRACE_ENABLE_DIS."
			<br/>
			<b>".FULL_TRACE_CHECK_ALL_DIS."</b>
			<input type='checkbox' id='checkall' onclick='checkallp();' onmouseover=\"Tip('".DEBUG_CHECK_ALL."')\" onmouseout='UnTip()'>
			<br/>" . $this->ports() .
			"<br/>
			<br/>
			</td>
			<td>
			<input type='checkbox' name='sip_sign' id='sip_sign' value='1' onclick='if (sip_sign.checked==true) sip_audio.disabled=false; else sip_audio.disabled=true;' checked/>Sip Sign
			<br/>
			<input type='checkbox' name='sip_audio' id='sip_audio' value='1' />Sip Audio
			</td>
			$td
			</tr>
			<tr>
			<td colspan='$colspan'>
			<img src='./includes/images/punkt_rot.gif'>&nbsp;&nbsp;&nbsp;
			<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_START_TRACE."')\" onmouseout='UnTip()' value='".FULL_TRACE_BUTTON_START_DIS."'>
			</td>
			</tr>
			</table></form><br/>";
		}

	//Wenn man auf den Knopf Stop clickt, wird die Module mISDNdebugtool gekillt
	} elseif ($_POST['trace'] == 'Stop Full Trace') {
		$bc = new beroConf('root');
		$log_date = (($bc->get('root', 'cifs_log_enabled') == '1') ? true : false);

		$fulltrace->stop($log_date);

		$ret .= "<br/><form class='extensions_form' method='POST'>
			<table class='contenttoc' style='width:473px;'>
			<tr><th colspan='$colspan'>".FULL_TRACE_TABLE_HEADER_DIS."</th></tr>
			<tr>
			<td>".FULL_TRACE_ISDN_PORTS_DIS."</td><td>".FULL_TRACE_SIP_DIS."</td>$th
			</tr>
			<tr>
			<td nowrap>
			<input type='checkbox' name='isdn_enable' id='isdn_enable' value='1' onclick='dis();' checked/>".FULL_TRACE_ENABLE_DIS."
			<br/>
			<b>".FULL_TRACE_CHECK_ALL_DIS."</b>
			<input type='checkbox' id='checkall' onclick='checkallp();' onmouseover=\"Tip('".DEBUG_CHECK_ALL."')\" onmouseout='UnTip()'>
			<br/>" . $this->ports() .
			"<br/>
			<br/>
			</td>
			<td>
			<input type='checkbox' name='sip_sign' id='sip_sign' value='1' onclick='if (sip_sign.checked==true) sip_audio.disabled=false; else sip_audio.disabled=true;' checked/>Sip Sign
			<br/>
			<input type='checkbox' name='sip_audio' id='sip_audio' value='1' />Sip Audio
			</td>
			$td
			</tr>
			<tr>
			<td colspan='$colspan'>
			<img src='./includes/images/punkt_rot.gif'>&nbsp;&nbsp;&nbsp;
			<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_START_TRACE."')\" onmouseout='UnTip()' value='".FULL_TRACE_BUTTON_START_DIS."'>
			</td>
			</tr>
			</table></form><br/>";
	//Wenn das Trace in Hindergrund läuft wird den Stop Knopf angezeigt
	} elseif ($ba->get('trace') == 'yes' ) {
			$ret .= "<br/><form class='extensions_form' method='POST'>" .
				"<table class='contenttoc' style='width:473px;'><tr><th colspan='2'>".FULL_TRACE_TABLE_HEADER_DIS."</th></tr><tr>" .
				"<td><img src='./includes/images/punkt_gruen.gif'></td>
				<td>
					<input type='submit' id='trace' name='trace' onmouseover=\"Tip('".DEBUG_STOP_TRACE."')\" onmouseout='UnTip()' value='Stop Full Trace'>
				</td></tr></table></form><br/>";
	}

	/*
	 * Überprüfung ob die dateien debug-info.tar.gz oder DebugFiles.tar.gz oder isgw.err,
	 * Wenn ja, wird einen Link für Download angeboten, und einen Link delete
	 * um die entsprechende Datei zu löschen
	 */
	if (file_exists("/var/log/debug-info.tar.gz") || file_exists("/var/log/DebugFiles.tar.gz") || file_exists("/var/log/isgw.err")){
		$ret.="<form class='extensions_form' method='POST'><table class='contenttoc' style='width:473px;'>
				<tr><th colspan='2'>".FULL_TRACE_DOWNLOADS_DIS."</th></tr>";
		if (file_exists("/var/log/debug-info.tar.gz"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_ISGW_COREDUMPS_DIS."</b>&nbsp;&nbsp;
			<input type='button' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='misc/isdn_trace.php?option=isgw';\" onmouseover=\"Tip('".DEBUG_DOWNLOAD_TRACE."')\" onmouseout='UnTip()'>&nbsp;&nbsp;
			<input type='button' value='".FULL_TRACE_BUTTON_DELETE_FILE_DIS."' onclick=\"javascript:if (confirm('".FULL_TRACE_DELETE_COREDUMPS_DIS."?')==true) window.location.href='misc/deletedatei.php';\" onmouseover=\"Tip('".DEBUG_DELETE."')\" onmouseout='UnTip()'></td>
			<td>".date("d M Y H:i",filectime("/var/log/debug-info.tar.gz"))."</td>
			</tr>";
		if (file_exists("/var/log/DebugFiles.tar.gz"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_DEBUG_FILES_DIS."</b>&nbsp;&nbsp;
			<input type='button' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='misc/isdn_trace.php';\" onmouseover=\"Tip('".DEBUG_DOWNLOAD_TRACE."')\" onmouseout='UnTip()'>&nbsp;&nbsp;
			<input type='button' value='".FULL_TRACE_BUTTON_DELETE_FILE_DIS."' onclick=\"javascript:if (confirm('".FULL_TRACE_DELETE_DEBUG_FILES_DIS."?')==true) window.location.href='misc/deletedatei.php?option=debug';\" onmouseover=\"Tip('".DEBUG_DELETE_FILES."')\" onmouseout='UnTip()'>
			<td>".date("d M Y H:i",filectime("/var/log/DebugFiles.tar.gz"))."</td>
			</tr>";
		if (file_exists("/var/log/isgw.err"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_ERROR_LOG_DIS."</b>&nbsp;&nbsp;
			<input type='button' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='misc/isdn_trace.php?option=error';\" >&nbsp;&nbsp;
			<td>".date("d M Y H:i",filectime("/var/log/isgw.err"))."</td>
			</tr>";
		if (file_exists("/var/log/cloud.log"))
		$ret.="<tr>
			<td nowrap style='text-align:left;'><b>".FULL_TRACE_CLOUD_LOG_DIS."</b>&nbsp;&nbsp;
			<input type='button' value='".FULL_TRACE_BUTTON_DOWNLOAD_DIS."' onclick=\" window.location.href='misc/isdn_trace.php?option=cloud';\" >&nbsp;&nbsp;
			<td>".date("d M Y H:i",filectime("/var/log/cloud.log"))."</td>
			</tr>";
		$ret.="</table></form><br/>";
	}


	//Rückgabe: Der Inhalt von der HTML-Seite
	return $ret;
}
}
?>
